# -*- coding: utf-8 -*-
# ASternGrossesFeld.py
### Vorgabe einer Schuelergruppe

# ----- A*-Graph -----
# Es werden in einem Dictionary die gesperrten Felder angegeben.
gesperrt={
    1:[2,6,14,18],
    2:[3,9,14,18],
    3:[2,6,8,14],
    4:[3,6,9,14,17,18,19,20],
    5:[14],
    6:[3,5,6,14],
    7:[3,7,10,11,12,14],
    8:[3,4,5,6,11],
    9:[13,14,15,16,17,18,19,20],
    10:[2,5,10],
    11:[2,6,9,13,14,15,16,17,18,19,20],
    12:[2,7,8],
    13:[],
    14:[2,20],
    15:[5,8,10,11,12,13,15,18],
    16:[5,8,10,15,18],
    17:[5,6,7,8,10,13,15,16,17,18],
    18:[5,8,10,13,15,18],
    19:[5,8,10,11,12,13,15,18],
    20:[2,20]
}
# zugehoerige Konstante:
kantenlaenge=20

# ----- Alternative als Liste -----
##gesperrt=[[], ## dummy um den Startindex 1 zu erzielen
##          [2,6,14,18],
##          [3,9,14,18],
##          [2,6,8,14],
##          [3,6,9,14,17,18,19,20],
##          [14],
##          [3,5,6,14],
##          [3,7,10,11,12,14],
##          [3,4,5,6,11],
##          [13,14,15,16,17,18,19,20],
##          [2,5,10],
##          [2,6,9,13,14,15,16,17,18,19,20],
##          [2,7,8],
##          [],
##          [2,20],
##          [5,8,10,11,12,13,15,18],
##          [5,8,10,15,18],
##          [5,6,7,8,10,13,15,16,17,18],
##          [5,8,10,13,15,18],
##          [5,8,10,11,12,13,15,18],
##          [2,20]
##          ]

# ----- unzulaessig -----
# gibt von einem Feld an, ob es zulässig ist.
def zulaessig(feld):
    for koordinate in feld:
        if koordinate<1: return False
        if koordinate>kantenlaenge: return False
    if feld[1] in gesperrt[feld[0]]: return False
    return True

# ----- nachfolger -----
# bestimmt die zulässigen Nachfolgefelder eines Felds
def nachfolger(feld):
    ergebnis=[]
    for fall in [[-1,0],[1,0],[0,-1],[0,1]]:
        if zulaessig([feld[0]+fall[0],feld[1]+fall[1]]):
            ergebnis+=[[feld[0]+fall[0],feld[1]+fall[1]]]
    return ergebnis

# ----- restkosten -----
# Bestimmt zu einem Feld seine geschätzten Restkosten
# nach der Manhattan-Distanz.
def restkosten(feld):
    global ziel
    return abs(feld[0]-ziel[0])+abs(feld[1]-ziel[1])

# ----- kosten -----
# Bestimmt zu einem Weg seine Kosten.
def kosten(weg):
    return len(weg)-1

# ----- gesamtKosten -----
# bestimmt die Gesamtkosten.
def gesamtKosten(weg):
    return kosten(weg)+restkosten(weg[len(weg)-1])

# ----- prioWS -----
# Funktionen zur Verwaltung der Prioritaetswarteschlange

# ----- kuerzer -----
# Hier muss das Vergleichsprädikat kuerzer neu definiert werden.
def kuerzer(weg1, weg2):
    return gesamtKosten(weg1)<gesamtKosten(weg2)

# ----- expandiere -----
# Außerdem muss die Expansionsfunktion neu definiert werden.
# Damit keine Zyklen entstehen, muessen die Fortsetzungen gefiltert werden.
def expandiere(weg):
    neueKnoten=nachfolger(weg[len(weg)-1])
    gefiltert=[]
    for ecke in neueKnoten:
        if not ecke in weg:
            gefiltert.append(ecke)
    neueWege=[]
    for i in range(len(gefiltert)):
        neueWege.append(weg+[gefiltert[i]])
    return neueWege
    

# ----- ordneEin -----
# Die Funktion ordnet einen einzelnen Weg ein.
def ordneEin(weg, sortierte):
    for index in range(len(sortierte)):
        if kuerzer(weg, sortierte[index]):
            sortierte[index:index]=[weg]
            return sortierte
    sortierte[len(sortierte):len(sortierte)]=[weg]
    return sortierte

# ----- ordneAlleEin -----
# Die Funktion ordnet eine Liste von wegn ein.
# [sortiert durch Einfügen]
def ordneAlleEin(wege, sortierte):
    for weg in wege:
        sortierte=ordneEin(weg, sortierte)
    return sortierte

# ----- expansionsSchritt -----
# nimmt das erste Element aus der Prioritätswarteschlange
# expandiert es und fügt die entstandenen Wege ein.
def expansionsSchritt(prioWS, ziel):
    wegZumZiel=None
    while wegZumZiel==None:
        prioWS=ordneAlleEin(expandiere(prioWS[0]), prioWS[1:])
        wegZumZiel=amZiel(prioWS, ziel)
    return wegZumZiel

def amZiel(prioWS, ziel):
    for weg in prioWS:
        if ziel in weg:
            return weg
    return None


# ----- aStern -----
def aStern(von, nach):
    global ziel
    ziel=nach
    return expansionsSchritt([[von]], ziel)

##print( aStern([3,3],[8,10]) )
##print( aStern([3,3],[9,11]) )
##print( aStern([3,3],[10,20]) )
##print( aStern([3,3],[14,13]))

### ===== zeigeFeldUndWeg =================================
def zeigeFeldUndWeg(breite,hoehe,weg):
    print("\nFeld und Weg\n")
    for i in range(1,breite+1):
        zeile=""
        for j in range(1,hoehe+1):
            if j in gesperrt[i]: zeile+="X "
            elif [i,j] in weg: zeile+="o "
            else: zeile+=". "
        print(zeile)
    print('Gesamtkosten:',gesamtKosten(weg))
    print()

zeigeFeldUndWeg(20,20,aStern([3,3],[14,14]))
##zeigeFeldUndWeg(20,20,aStern([3,3],[17,12]))
